"""
Note: This program uses only the tools that we have studied so far in class.

"""

def isLeapYear(year):
    if year % 4 == 0:
        if year % 100 == 0 and year % 400 != 0:
            return False
        return True
    else:
        return False


def isYearValid(year):
    if year >= 0:
        return True
    else:
        return False

def isMonthValid(month):
    if month >= 1 and month <= 12:
        return True
    else:
        return False

def isDayValid(day):
    if day >= 1 and day <= 31:
        return True
    else:
        return False

def isDateValid(date):
    if type(date) is not str:
        return False
    else:
        num_of_slashes = 0
        month = ""
        day = ""
        year = ""
        for c in date:            
            if c == "/":
                num_of_slashes = num_of_slashes + 1

            if num_of_slashes == 0:
                month = month + c

            if num_of_slashes == 1 and c != "/":
                day = day + c

            if num_of_slashes == 2 and c != "/":
                year = year + c              

        
        #isdigit() is a function in string class. It returns True if all characters
        #in a string are digits. It not, it returns False.
        if num_of_slashes != 2 or not month.isdigit() or not day.isdigit() or not year.isdigit():                
            return False
        else:
            m = int(month)
            d = int(day)
            y = int(year)
            if not isMonthValid(m) or not isDayValid(d) or not isYearValid(y):
                return False
            else:
                #This condition involves Jan, Feb, March, April, May, June and July.
                if m <= 7:
                    #First, we handle the Feb month, which is 28 days in common years
                    #and 29 days in leap years.
                    if m == 2:
                        if isLeapYear(y) and d > 29:
                            return False
                        elif not isLeapYear(y) and d > 28:
                            return False
                        else:
                            return True
                    else:
                        #This condition takes care of the months of April and June.
                        if m % 2 == 0 and d > 30:
                            return False
                        else:
                            #This takes care of the months of Jan, March, May, and July.
                            return True
                #Second, we handle the months from August till December, inclusive. 
                else:
                    if m % 2 == 1 and d > 30:
                        return False
                    else:                        
                        return True
    

def computeYearDays(date):
    v = isDateValid(date)
    if v:
        """
        Extract the month, day, and year from the date.
        Caveat: This is not necessarily the best way of doing it. In particular,
        this part is a duplicate of what we did in the isDateValid function. We can
        instead write this part as a seperate function and call it in this function
        as well as in the isDateValid function.

        """
        num_of_slashes = 0
        month = ""
        day = ""
        year = ""
        for c in date:            
            if c == "/":
                num_of_slashes = num_of_slashes + 1

            if num_of_slashes == 0:
                month = month + c

            if num_of_slashes == 1 and c != "/":
                day = day + c

            if num_of_slashes == 2 and c != "/":
                year = year + c

        #We know for sure that the month, day, and year are valid because the date is valid.
        m = int(month)
        d = int(day)
        y = int(year)

        dayNum = 31 * (m - 1) + d
        if m > 2:
            dayNum = dayNum - ((4 * m) + 23)//10
            
        if isLeapYear(y) and m > 2:
            dayNum = dayNum + 1

        return dayNum
    
    else:
        #The -1 indicates that the input is invalid.
        return -1



def testDate():
    date = input("Enter a date in the form month/day/year: ")
    if isDateValid(date):
        print(date, "is valid!")
    else:
        print(date, "is invalid.")
    
#testDate()

def testComputeYearDays():
    date = input("Enter a date in the form month/day/year: ")
    number_of_days = computeYearDays(date)
    if number_of_days == -1:
        print(date, "is invalid.")
    else:
        print("Number of days in this" , date, "is thus far", number_of_days)

testComputeYearDays()
